<html>
<head>
<title>OgreShaderFFPColour.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderFFPColour.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderFFPColour_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE.</span>
<a name="l00025"></a>00025 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef _ShaderFFPColur_</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define _ShaderFFPColur_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderPrerequisites_8h.html">OgreShaderPrerequisites.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#ifdef RTSHADER_SYSTEM_BUILD_CORE_SHADERS</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="OgreShaderSubRenderState_8h.html">OgreShaderSubRenderState.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderParameter_8h.html">OgreShaderParameter.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 <span class="keyword">namespace </span>RTShader {
<a name="l00037"></a>00037 
<a name="l00048"></a>00048 <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> FFPColour : <span class="keyword">public</span> SubRenderState
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050 <span class="keyword">public</span>:
<a name="l00051"></a>00051 
<a name="l00052"></a>00052     <span class="comment">// Parameter stage flags of the colour component.</span>
<a name="l00053"></a>00053     <span class="keyword">enum</span> StageFlags
<a name="l00054"></a>00054     {
<a name="l00055"></a>00055         SF_VS_INPUT_DIFFUSE     = 1 &lt;&lt; 1,
<a name="l00056"></a>00056         SF_VS_INPUT_SPECULAR    = 1 &lt;&lt; 2,
<a name="l00057"></a>00057         SF_VS_OUTPUT_DIFFUSE    = 1 &lt;&lt; 3,
<a name="l00058"></a>00058         SF_VS_OUTPUT_SPECULAR   = 1 &lt;&lt; 4,
<a name="l00059"></a>00059         SF_PS_INPUT_DIFFUSE     = 1 &lt;&lt; 5,
<a name="l00060"></a>00060         SF_PS_INPUT_SPECULAR    = 1 &lt;&lt; 6,
<a name="l00061"></a>00061         SF_PS_OUTPUT_DIFFUSE    = 1 &lt;&lt; 7,
<a name="l00062"></a>00062         SF_PS_OUTPUT_SPECULAR   = 1 &lt;&lt; 8
<a name="l00063"></a>00063     };
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 <span class="comment">// Interface.</span>
<a name="l00066"></a>00066 <span class="keyword">public</span>:
<a name="l00067"></a>00067 
<a name="l00069"></a>00069     FFPColour();
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00075"></a>00075     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;   getType                 () <span class="keyword">const</span>;
<a name="l00076"></a>00076 
<a name="l00080"></a>00080     <span class="keyword">virtual</span> <span class="keywordtype">int</span>             getExecutionOrder       () <span class="keyword">const</span>;
<a name="l00081"></a>00081 
<a name="l00085"></a>00085     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            copyFrom                (<span class="keyword">const</span> SubRenderState&amp; rhs);
<a name="l00086"></a>00086 
<a name="l00090"></a>00090     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            preAddToRenderState     (<span class="keyword">const</span> RenderState* renderState, Pass* srcPass, Pass* dstPass);
<a name="l00091"></a>00091 
<a name="l00098"></a>00098     <span class="keywordtype">void</span>                setResolveStageFlags        (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> flags) { mResolveStageFlags = flags; }
<a name="l00099"></a>00099 
<a name="l00103"></a>00103     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>        getResolveStageFlags        ()<span class="keyword"> const             </span>{ <span class="keywordflow">return</span> mResolveStageFlags; }
<a name="l00104"></a>00104 
<a name="l00109"></a>00109     <span class="keywordtype">void</span>                addResolveStageMask         (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> mask)  { mResolveStageFlags |= mask; }
<a name="l00110"></a>00110 
<a name="l00115"></a>00115     <span class="keywordtype">void</span>                removeResolveStageMask      (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> mask)  { mResolveStageFlags &amp;= ~mask; }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117     <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> Type;
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 <span class="comment">// Protected methods</span>
<a name="l00120"></a>00120 <span class="keyword">protected</span>:  
<a name="l00121"></a>00121     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            resolveParameters       (ProgramSet* programSet);   
<a name="l00122"></a>00122     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            resolveDependencies     (ProgramSet* programSet);
<a name="l00123"></a>00123     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            addFunctionInvocations  (ProgramSet* programSet);
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 <span class="comment">// Attributes.</span>
<a name="l00126"></a>00126 <span class="keyword">protected</span>:
<a name="l00127"></a>00127     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>    mVSInputDiffuse;            <span class="comment">// Vertex shader input diffuse component.</span>
<a name="l00128"></a>00128     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>    mVSInputSpecular;           <span class="comment">// Vertex shader input specular component.</span>
<a name="l00129"></a>00129     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>    mVSOutputDiffuse;           <span class="comment">// Vertex shader output diffuse component.</span>
<a name="l00130"></a>00130     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>    mVSOutputSpecular;          <span class="comment">// Vertex shader input specular component.</span>
<a name="l00131"></a>00131     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>    mPSInputDiffuse;            <span class="comment">// Pixel shader input diffuse component.</span>
<a name="l00132"></a>00132     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>    mPSInputSpecular;           <span class="comment">// Pixel shader input specular component.</span>
<a name="l00133"></a>00133     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>    mPSOutputDiffuse;           <span class="comment">// Pixel shader output diffuse component.</span>
<a name="l00134"></a>00134     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>    mPSOutputSpecular;          <span class="comment">// Pixel shader input specular component.</span>
<a name="l00135"></a>00135     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>    mResolveStageFlags;         <span class="comment">// Stage flags that defines resolve parameters definitions.</span>
<a name="l00136"></a>00136 };
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00143"></a>00143 <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> FFPColourFactory : <span class="keyword">public</span> SubRenderStateFactory
<a name="l00144"></a>00144 {
<a name="l00145"></a>00145 <span class="keyword">public</span>:
<a name="l00146"></a>00146 
<a name="l00150"></a>00150     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;   getType             () <span class="keyword">const</span>;
<a name="l00151"></a>00151 
<a name="l00155"></a>00155     <span class="keyword">virtual</span> SubRenderState* createInstance      (ScriptCompiler* compiler, PropertyAbstractNode* prop, Pass* pass, SGScriptTranslator* translator);
<a name="l00156"></a>00156 
<a name="l00160"></a>00160     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            writeInstance       (MaterialSerializer* ser, SubRenderState* subRenderState, Pass* srcPass, Pass* dstPass);
<a name="l00161"></a>00161 
<a name="l00162"></a>00162     
<a name="l00163"></a>00163 <span class="keyword">protected</span>:
<a name="l00164"></a>00164 
<a name="l00168"></a>00168     <span class="keyword">virtual</span> SubRenderState* createInstanceImpl  ();
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 };
<a name="l00172"></a>00172 
<a name="l00176"></a>00176 }
<a name="l00177"></a>00177 }
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 <span class="preprocessor">#endif</span>
<a name="l00180"></a>00180 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
